﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

//using Lucene.Net.Index;
//using Lucene.Net.Store;
//using LuceneDocs = Lucene.Net.Documents;  //namespace collision with DocumentFormat.OpenXml so I gave it an alias
//using Lucene.Net.Analysis.Standard;
using Lucene.Net.Store.Azure;
using Lucene.Net.Search;
using Lucene.Net.Documents;
using Lucene.Net.QueryParsers;
using Lucene.Net.Analysis.Standard;

using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace WCFServiceWebRole1
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    public class SearchService : ISearchService
    {
        public List<SearchResult> Search(string SearchTerms)
        {
            List<SearchResult> retval = new List<SearchResult>();

            CloudStorageAccount.SetConfigurationSettingPublisher((configName,
                                          configSettingPublisher) =>
            {
                string configValue = RoleEnvironment.GetConfigurationSettingValue(configName);
                configSettingPublisher(configValue);
            });


            CloudStorageAccount storageAccount = CloudStorageAccount.FromConfigurationSetting("StorageAccount");
            CloudBlobClient BlobClient = storageAccount.CreateCloudBlobClient();

            //open index
            AzureDirectory azureDirectory = new AzureDirectory(storageAccount, "cloudindex");
            IndexSearcher searcher = new IndexSearcher(azureDirectory);

            //for the sample I'm just searching the body
            QueryParser parser = new QueryParser("Body", new StandardAnalyzer());
            Query query = parser.Parse("Body:(" + SearchTerms + ")");
            Hits hits = searcher.Search(query);

            for (int idxResults = 0; idxResults < hits.Length(); idxResults++)
            {
                SearchResult newSearchResult = new SearchResult();
                Document doc = hits.Doc(idxResults); 


                newSearchResult.Title  = doc.GetField("Title").StringValue();
                newSearchResult.Uri = doc.GetField("Uri").StringValue();
                
                retval.Add(newSearchResult);
            }

            return retval;
        }

        public CompositeType GetDataUsingDataContract(CompositeType composite)
        {
            if (composite == null)
            {
                throw new ArgumentNullException("composite");
            }
            if (composite.BoolValue)
            {
                composite.StringValue += "Suffix";
            }
            return composite;
        }
    }


}
